////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Form1 Data and Objects - The Main Digitizer Window

int BitmapTiles[16 * xtiles * ytiles];  //this is tile data working buffer for graphics  
int* bitmap_base = (int*)BitmapTiles;



//typedef struct
//{
//    int x;
//    float y;
//    char z[16];
//}S, * S_t;

FormButton Form1Button1 = {
    ButtonType,              //Object type button==1
    10,              //Top tile #
    3,        //Left tile #
    11,    //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Green2, //Text foreground color
    NavyBlue,   //Text background color  (usually same as inside color)
    NavyBlue,   //border color
    Green2,    //border color when highlighted
    Gallery,    //color outside button (usually same as form background)
    NavyBlue,   //color inside button
    0,              //Hot key position (0 for none)
    Red,        //Color for hot key character
    1,              //Style:  0=square, 1=round
    "Start", //Button text
    &HandleButtonUpSpecialForm1               //OnClick function
};

FormButton Form1Button2 = {
    ButtonType,               //Object type button==1
    10,              //Top tile #
    15,        //Left tile #
    11,    //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    RedOrange, //Text foreground color
    NavyBlue,   //Text background color  (usually same as inside color)
    NavyBlue,   //border color
    Green2,    //border color when highlighted
    Gallery,    //color outside button (usually same as form background)
    NavyBlue,   //color inside button
    0,              //Hot key position (0 for none)
    Red,        //Color for hot key character
    1,              //Style:  0=square, 1=round
    "Stop", //Button text
    &HandleButtonUpSpecialForm1              //OnClick function
};

FormButton Form1Button3 = {
    ButtonType,               //Object type button==1
    14,              //Top tile #
    3,        //Left tile #
    11,    //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Yellow, //Text foreground color
    NavyBlue,   //Text background color  (usually same as inside color)
    NavyBlue,   //border color
    Green2,    //border color when highlighted
    Gallery,    //color outside button (usually same as form background)
    NavyBlue,   //color inside button
    0,              //Hot key position (0 for none)
    Red,        //Color for hot key character
    1,              //Style:  0=square, 1=round
    "Single", //Button text
    &HandleButtonUpSpecialForm1               //OnClick function
};

FormButton Form1Button4 = {
    ButtonType,               //Object type button==1
    5,              //Top tile #
    30,        //Left tile #
    22,    //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Periwinkle, //Text foreground color
    NavyBlue,   //Text background color  (usually same as inside color)
    NavyBlue,   //border color
    Green2,    //border color when highlighted
    Gallery,    //color outside button (usually same as form background)
    NavyBlue,   //color inside button
    0,              //Hot key position (0 for none)
    Red,        //Color for hot key character
    1,              //Style:  0=square, 1=round
    "Configure Smartpins", //Button text
    0               //OnClick function
};

FormButton Form1Button5 = {
    ButtonType,               //Object type button==1
    5,              //Top tile #
    52,        //Left tile #
    22,    //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Periwinkle, //Text foreground color
    NavyBlue,   //Text background color  (usually same as inside color)
    NavyBlue,   //border color
    Green2,    //border color when highlighted
    Gallery,    //color outside button (usually same as form background)
    NavyBlue,   //color inside button
    0,              //Hot key position (0 for none)
    Red,        //Color for hot key character
    1,              //Style:  0=square, 1=round
    "View/Set Pins", //Button text
    0               //OnClick function
};

FormButton Form1Button6 = {
    ButtonType,              //Object type button==1
    5,              //Top tile #
    52 + 22,        //Left tile #
    22,    //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Periwinkle, //Text foreground color
    NavyBlue,   //Text background color  (usually same as inside color)
    NavyBlue,   //border color
    Green2,    //border color when highlighted
    Gallery,    //color outside button (usually same as form background)
    NavyBlue,   //color inside button
    0,              //Hot key position (0 for none)
    Red,        //Color for hot key character
    1,              //Style:  0=square, 1=round
    "Play Wave File", //Button text
    0               //OnClick function
};

FormText Form1Text1 = {
    TextType,              //Object type text==2
    30,              //Top tile #
    4,        //Left tile #
    36 - 22 + 1,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Gallery,   //Text background color 
    "Delay: 50%    " //Button text
};

FormText Form1Text2 = {
    TextType,              //Object type text==2
    7,              //Top tile #
    4,        //Left tile #
    29 - 22 + 1,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    NavyBlue, //Text foreground color
    Gallery,   //Text background color 
    "Status:" //Button text
};

FormText Form1Text3 = {
    TextType,              //Object type text==2
    30 - 5 - 1,              //Top tile #
    4,        //Left tile #
    35 - 22 + 1,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Gallery,   //Text background color 
    "Pin:" //Button text
};

FormText Form1Text4 = {
    TextType,              //Object type text==2
    42 - 5,              //Top tile #
    4,        //Left tile #
    28 - 22 + 1,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Gallery,   //Text background color 
    "Mode:       Edge:" //Button text
};

FormText Form1Text5 = {
    TextType,              //Object type text==2
    50,              //Top tile #
    4,        //Left tile #
    39 - 22 + 1,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Gallery,   //Text background color 
    "Clocks Per Point=\0                    " //Button text
};

FormText Form1Text6 = {
    TextType,              //Object type text==2
    53,              //Top tile #
    4,        //Left tile #
    39 - 22 + 1,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Gallery,   //Text background color 
    "Coarse       Fine" //Button text
};

FormText Form1Text7 = {
    TextType,              //Object type text==2
    22,              //Top tile #
    31,        //Left tile #
    39 - 22 + 1,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Gallery,   //Text background color 
    {'A','1',3,+7,4,-2,'A','2',
    3,+6,4,-2,'D','1',3,+5,4,-2,'D','2',
    3,+5,4,-2,'D','3',3,+5,4,-2,'D','4',
    3,+5,4,-2,'D','5',3,+5,4,-2,'D','6',
    0} //Button text
};

FormText Form1Text8 = {
    TextType,              //Object type text==2
    24,              //Top tile #
    14 + 3,        //Left tile #
    36 - 22 + 1,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Gallery,   //Text background color 
    "Level:" //Button text
};

FormText Form1Text9 = {
    TextType,             //Object type text==2
    12,              //Top tile #
    39 + 30,        //Left tile #
    6,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    NavyBlue, //Text foreground color
    Gallery,   //Text background color 
    {16,'C','l','o','c','k','s',':',0} //Button text
};

FormText Form1Text10 = {
    TextType,              //Object type text==2
    14,              //Top tile #
    39 + 30,        //Left tile #
    6,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    NavyBlue, //Text foreground color
    Gallery,   //Text background color 
    "Freq:                    " //Button text
};

FormText Form1Text11 = {
    TextType,              //Object type text==2
    17,              //Top tile #
    106,        //Left tile #
    6,    //Width in tiles
    2,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Gallery,   //Text background color 
    "Gain" //Button text
};

FormGroup Form1Group1 = {
    GroupType,              //Object type text==2
    4,              //Top tile #
    2,        //Left tile #
    26,    //Width in tiles
    15,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Black,   //Text background color 
    "Acquisition" //Button text
};

FormGroup Form1Group2 = {
    GroupType,              //Object type text==2
    26 - 5,              //Top tile #
    2,        //Left tile #
    26,    //Width in tiles
    24,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Black,   //Text background color 
    "Trigger" //Button text
};

FormGroup Form1Group3 = {
    GroupType,              //Object type text==2
    47,              //Top tile #
    2,        //Left tile #
    26,    //Width in tiles
    14,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Black,   //Text background color 
    "Horizontal" //Button text
};

FormGroup Form1Group4 = {
    GroupType,              //Object type text==2
    9,              //Top tile #
    30,        //Left tile #
    26+36,    //Width in tiles
    9,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black, //Text foreground color
    Black,   //Text background color 
    "Cursors" //Button text
};

FormOption Form1Option1 = {
    OptionType,              //Object type option=5
    45 - 5,              //Top tile #
    10 + 7,        //Left tile #
    34 - 22,    //Width in tiles
    2,              //Height in tiles
    0,              //data
    0,              //status
    Black, //Text foreground color
    Black,   //outer color 
    Gallery,  //inner color
    RedBerry, //core color
    1, //group
    &HandleOptionSpecialForm1, //function to call when changed
    true,  //Selected?
    "Rising" //Button text
};

FormOption Form1Option2 = {
    OptionType,             //Object type option=5
    47 - 5,              //Top tile #
    10 + 7,        //Left tile #
    34 - 22,    //Width in tiles
    2,              //Height in tiles
    0,              //data
    0,              //status
    Black, //Text foreground color
    Black,   //outer color 
    Gallery,  //inner color
    RedBerry, //core color
    1, //group
    &HandleOptionSpecialForm1, //function to call when changed
    false,  //Selected?
    "Falling" //Button text
};

FormOption Form1Option3 = {
    OptionType,              //Object type option=5
    45 - 5,              //Top tile #
    10 - 5,        //Left tile #
    34 - 22,    //Width in tiles
    2,              //Height in tiles
    0,              //data
    0,              //status
    Black, //Text foreground color
    Black,   //outer color 
    Gallery,  //inner color
    RedBerry, //core color
    2, //group
    &HandleOptionSpecialForm1, //function to call when changed
    false,  //Selected?
    "Digital" //Button text
};

FormOption Form1Option4 = {
    OptionType,              //Object type option=5
    47 - 5,              //Top tile #
    10 - 5,        //Left tile #
    34 - 22,    //Width in tiles
    2,              //Height in tiles
    0,              //data
    0,              //status
    Black, //Text foreground color
    Black,   //outer color 
    Gallery,  //inner color
    RedBerry, //core color
    2, //group
    &HandleOptionSpecialForm1, //function to call when changed
    true,  //Selected?
    "Analog" //Button text
};

FormOption Form1Option5 = {
    OptionType,              //Object type option=5
    12,              //Top tile #
    32,        //Left tile #
    5,    //Width in tiles
    2,              //Height in tiles
    0,              //data
    0,              //status
    Black, //Text foreground color
    Black,   //outer color 
    Gallery,  //inner color
    RedBerry, //core color
    3, //group
    &HandleOptionSpecialForm1, //function to call when changed
    true,  //Selected?
    "1                                " //Button text
};

FormOption Form1Option6 = {
    OptionType,              //Object type option=5
    14,              //Top tile #
    32,        //Left tile #
    5,    //Width in tiles
    2,              //Height in tiles
    0,              //data
    0,              //status
    Black, //Text foreground color
    Black,   //outer color 
    Gallery,  //inner color
    RedBerry, //core color
    3, //group
    &HandleOptionSpecialForm1, //function to call when changed
    false,  //Selected?
    "2                                " //Button text
};

FormCheck Form1Check1 = {
    CheckType,              //Object type check=6
    16,              //Top tile #
    32,        //Left tile #
    6,    //Width in tiles
    2,              //Height in tiles
    0,              //data
    0,              //status
    Black, //Text foreground color
    Black,   //outer color 
    Malibu,  //inner color
    Gallery, //check color
    false,  //Selected?
    "Show" //Button text
};

#define slider1width (18)
#define slider1height (2)
int Form1Slider1Data[slider1height * slider1width * 16];
int dpoints = dig.points;
FormSlider Form1Slider1 = {  //Horizontal slider
    SliderType,               //0 type 8=Graphical slider
    37 - 5 + 1,//33 - 5              //1 top
    6 - 2,             //2 left 
    slider1width,    //3 width
    slider1height,   //4 height  
    0,               //5 data
    0,               //6 status
    Gallery,          //7 background color
    Black,           //8 range Bar and tic color
    CornflowerBlue,  //9 Outside of position Line
    White,           //10 Center of position line
    dig.points - 1,    //11 Max. Value
    0,               //12 Min. Value
    dig.points / 2,  //13 Current Value
    30,              //14 Current pixel offset
    11,              //15 Number of tics
    0,              //16 Style 0=horizontal, 1=vertical
    &Form1Slider1Data[0],//17 Store for graphics slider pixels  //Note:  Same result when set to just "Form1Slider1Data"
    &HandleWaitMouseUpSpecialForm1 //18 Function to call when mouse is down on this object
};

#define slider2width (2)
#define slider2height (8)
int Form1Slider2Data[slider2height * slider2width * 16];
FormSlider Form1Slider2 = {  //Verical slider
    SliderType,               //0 type 8=Graphical slider
    24,              //1 top
    24,             //2 left 
    slider2width,    //3 width
    slider2height,   //4 height  
    0,               //5 data
    0,               //6 status
    Gallery,          //7 background color
    Black,           //8 range Bar and tic color
    CornflowerBlue,  //9 Outside of position Line
    White,           //10 Center of position line
    255,    //11 Max. Value
    0,               //12 Min. Value
    128,  //13 Current Value
    30,              //14 Current pixel offset
    11,              //15 Number of tics
    1,              //16 Style 0=horizontal, 1=vertical
    &Form1Slider2Data[0],//17 Store for graphics slider pixels  //Note:  Same result when set to just "Form1Slider2Data"
    & HandleWaitMouseUpSpecialForm1 //18 Function to call when mouse is down on this object
};

#define dial1width (6)
#define dial1height (6)
int Form1Dial1Data[dial1width * dial1height * 16];
FormDial Form1Dial1 = { //Coarse Timebase Dial knob
    DialType,               //0 Object type Dial=10
    55,                //1 Top tile #
    6,               //2 Left tile #
    dial1width,              //3 Width in tiles
    dial1height,             //4 Height in tiles
    0,               //5 user data
    0,             //6 status
    Gallery,          //7 background color
    Black,     //8 dial indicator color
    Gray,           //9 dial tic color
    OrangePeel,          //10 dial color
    16,                //11 max value
    0,                //12 min value
    0,              //13 current value
    -1600,              //14 Current angle (degrees*10): 0=up, -900=left, 900=right
    -1600,         //15 starting angle
    1600,           //16 ending angle
    16,               //17 number of tics (actually, number of subdivisions)
    1,              //18 dial style 0=regular, 1=snapped to tics
    &Form1Dial1Data[0],              //19 pointer to storage for graphics pixels
    &HandleWaitMouseUpSpecialForm1 //20 Function to call when mouse is down on this object
};

int Form1Dial2Data[dial1width * dial1height * 16];  //same dimensions as Dial#1
FormDial Form1Dial2 = { //Coarse Timebase Dial knob
    DialType,               //0 Object type Dial=10
    55,                //1 Top tile #
    18,               //2 Left tile #
    dial1width,              //3 Width in tiles
    dial1height,             //4 Height in tiles
    0,               //5 user data
    0,             //6 status
    Gallery,          //7 background color
    Black,     //8 dial indicator color
    Gray,           //9 dial tic color
    CornflowerBlue,          //10 dial color
    255,                //11 max value
    0,                //12 min value
    0,              //13 current value
    -1600,              //14 Current angle (degrees*10): 0=up, -900=left, 900=right
    -1600,         //15 starting angle
    1600,           //16 ending angle
    1,               //17 number of tics (actually, number of subdivisions)
    0,              //18 dial style 0=regular, 1=snapped to tics
    &Form1Dial2Data[0],              //19 pointer to storage for graphics pixels
    &HandleWaitMouseUpSpecialForm1 //20 Function to call when mouse is down on this object
};

int Form1DialA1Data[dial1width * dial1height * 16];  //same dimensions as Dial#1
FormDial Form1DialA1 = { //Gain for channel A1
    DialType,               //0 Object type Dial=10
    21,                //1 Top tile #
    106,               //2 Left tile #
    dial1width,              //3 Width in tiles
    dial1height,             //4 Height in tiles
    0,               //5 user data
    0,             //6 status
    Gallery,          //7 background color
    Black,     //8 dial indicator color
    Gray,           //9 dial tic color
    TorchRed,          //10 dial color
    4,                //11 max value
    0,                //12 min value
    0,              //13 current value
    -1000,              //14 Current angle (degrees*10): 0=up, -900=left, 900=right
    -1000,         //15 starting angle
    1000,           //16 ending angle
    4,               //17 number of tics (actually, number of subdivisions)
    1,              //18 dial style 0=regular, 1=snapped to tics
    &Form1DialA1Data[0],              //19 pointer to storage for graphics pixels
    &HandleWaitMouseUpSpecialForm1 //20 Function to call when mouse is down on this object
};

int Form1DialA2Data[dial1width * dial1height * 16];  //same dimensions as Dial#1
FormDial Form1DialA2 = { //Gain for channel A2
    DialType,               //0 Object type Dial=10
    28,                //1 Top tile #
    106,               //2 Left tile #
    dial1width,              //3 Width in tiles
    dial1height,             //4 Height in tiles
    0,               //5 user data
    0,             //6 status
    Gallery,          //7 background color
    Black,     //8 dial indicator color
    Gray,           //9 dial tic color
    TorchRed,          //10 dial color
    4,                //11 max value
    0,                //12 min value
    0,              //13 current value
    -1000,              //14 Current angle (degrees*10): 0=up, -900=left, 900=right
    -1000,         //15 starting angle
    1000,           //16 ending angle
    4,               //17 number of tics (actually, number of subdivisions)
    1,              //18 dial style 0=regular, 1=snapped to tics
    &Form1DialA2Data[0],              //19 pointer to storage for graphics pixels
    &HandleWaitMouseUpSpecialForm1 //20 Function to call when mouse is down on this object
};



FormNumberEdit Form1NumberEdit1 = {
    NumberEditType,             //Object type = NumberEdit
    33 - 8 - 1,     //Top tile #
    20 - 11,        //Left tile #
    2,              //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    White,          //Text foreground color
    RedBerry,       //Text background color
    Gallery,        //button color 0
    NavyBlue,       //button color 1
    Yellow,         //button color 2
    Yellow,         //button color 3
    35,              //value
    0,              //min. value
    63,             //max. vlaue
    2,              //#digits    
    10,             //base (10,2,16)
    &HandleNumberEditSpecialForm1,            //function to call when changed
    false,          //Show sign?               //This moved from above to below base due to bug in FlexSpin
    true,           //show buttons?
    false           //Affect only clicked digit?
    
};

FormNumberEdit Form1NumberEditD1 = {
    NumberEditType,             //Object type = NumberEdit
    27 + 8,     //Top tile #
    35,        //Left tile #
    2,              //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    White,          //Text foreground color
    RedBerry,       //Text background color
    Gallery,        //button color 0
    NavyBlue,       //button color 1
    Yellow,         //button color 2
    Yellow,         //button color 3
    44,              //value
    00,              //min. value
    63,             //max. vlaue
    2,              //#digits    
    10,             //base (10,2,16)
    &HandleNumberEditSpecialForm1,            //function to call when changed
    false,          //Show sign?               //This moved from above to below base due to bug in FlexSpin
    true,           //show buttons?
    false           //Affect only clicked digit?
};


int Form1GraphicsD1Data[64 * 4 * 16];
FormGraphicsArea Form1GraphicsD1 = {
    GraphicsAreaType,   //Object type GraphicsAreaType             
    27 + 8,                //Top tile #
    40,               //Left tile #
    64,              //Width in tiles
    4,             //Height in tiles
    0,               //user data
    0,             //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black,             //color #0
    Onahau,             //color #1
    BuddhaGold,             //color #2
    Green,             //color #3
    0,            //x origin pixel
    0,            //y origin pixel
    Form1GraphicsD1Data,             //pointer to pixel data
    NULL  //click function pointer
};

FormNumberEdit Form1NumberEditD2 = {
    NumberEditType,             //Object type = NumberEdit
    32 + 8,     //Top tile #
    35,        //Left tile #
    2,              //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    White,          //Text foreground color
    RedBerry,       //Text background color
    Gallery,        //button color 0
    NavyBlue,       //button color 1
    Yellow,         //button color 2
    Yellow,         //button color 3
    45,              //value
    00,              //min. value
    63,             //max. vlaue
    2,              //#digits    
    10,             //base (10,2,16)
    &HandleNumberEditSpecialForm1,            //function to call when changed
    false,          //Show sign?               //This moved from above to below base due to bug in FlexSpin
    true,           //show buttons?
    false           //Affect only clicked digit?
};


int Form1GraphicsD2Data[64 * 4 * 16];
FormGraphicsArea Form1GraphicsD2 = {
    GraphicsAreaType,   //Object type GraphicsAreaType             
    32 + 8,                //Top tile #
    40,               //Left tile #
    64,              //Width in tiles
    4,             //Height in tiles
    0,               //user data
    0,             //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black,             //color #0
    Onahau,             //color #1
    BuddhaGold,             //color #2
    Green,             //color #3
    0,            //x origin pixel
    0,            //y origin pixel
    Form1GraphicsD2Data,             //pointer to pixel data
    NULL  //click function pointer
};

FormNumberEdit Form1NumberEditD3 = {
    NumberEditType,             //Object type = NumberEdit
    37 + 8,     //Top tile #
    35,        //Left tile #
    2,              //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    White,          //Text foreground color
    RedBerry,       //Text background color
    Gallery,        //button color 0
    NavyBlue,       //button color 1
    Yellow,         //button color 2
    Yellow,         //button color 3
    46,              //value
    00,              //min. value
    63,             //max. vlaue
    2,              //#digits    
    10,             //base (10,2,16)
    &HandleNumberEditSpecialForm1,            //function to call when changed
    false,          //Show sign?               //This moved from above to below base due to bug in FlexSpin
    true,           //show buttons?
    false           //Affect only clicked digit?
};


int Form1GraphicsD3Data[64 * 4 * 16];
FormGraphicsArea Form1GraphicsD3 = {
    GraphicsAreaType,   //Object type GraphicsAreaType             
    37 + 8,                //Top tile #
    40,               //Left tile #
    64,              //Width in tiles
    4,             //Height in tiles
    0,               //user data
    0,             //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black,             //color #0
    Onahau,             //color #1
    BuddhaGold,             //color #2
    Green,             //color #3
    0,            //x origin pixel
    0,            //y origin pixel
    Form1GraphicsD3Data,             //pointer to pixel data
    NULL  //click function pointer
};

FormNumberEdit Form1NumberEditD4 = {
    NumberEditType,             //Object type = NumberEdit
    42 + 8,     //Top tile #
    35,        //Left tile #
    2,              //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    White,          //Text foreground color
    RedBerry,       //Text background color
    Gallery,        //button color 0
    NavyBlue,       //button color 1
    Yellow,         //button color 2
    Yellow,         //button color 3
    47,              //value
    00,              //min. value
    63,             //max. vlaue
    2,              //#digits    
    10,             //base (10,2,16)
    &HandleNumberEditSpecialForm1,            //function to call when changed
    false,          //Show sign?               //This moved from above to below base due to bug in FlexSpin
    true,           //show buttons?
    false           //Affect only clicked digit?
};


int Form1GraphicsD4Data[64 * 4 * 16];
FormGraphicsArea Form1GraphicsD4 = {
    GraphicsAreaType,   //Object type GraphicsAreaType             
    42 + 8,                //Top tile #
    40,               //Left tile #
    64,              //Width in tiles
    4,             //Height in tiles
    0,               //user data
    0,             //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black,             //color #0
    Onahau,             //color #1
    BuddhaGold,             //color #2
    Green,             //color #3
    0,            //x origin pixel
    0,            //y origin pixel
    Form1GraphicsD4Data,             //pointer to pixel data
    NULL  //click function pointer
};

FormNumberEdit Form1NumberEditD5 = {
    NumberEditType,             //Object type = NumberEdit
    47 + 8,     //Top tile #
    35,        //Left tile #
    2,              //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    White,          //Text foreground color
    RedBerry,       //Text background color
    Gallery,        //button color 0
    NavyBlue,       //button color 1
    Yellow,         //button color 2
    Yellow,         //button color 3
    48,              //value
    00,              //min. value
    63,             //max. vlaue
    2,              //#digits    
    10,             //base (10,2,16)
    &HandleNumberEditSpecialForm1,            //function to call when changed
    false,          //Show sign?               //This moved from above to below base due to bug in FlexSpin
    true,           //show buttons?
    false           //Affect only clicked digit?
};


int Form1GraphicsD5Data[64 * 4 * 16];
FormGraphicsArea Form1GraphicsD5 = {
    GraphicsAreaType,   //Object type GraphicsAreaType             
    47 + 8,                //Top tile #
    40,               //Left tile #
    64,              //Width in tiles
    4,             //Height in tiles
    0,               //user data
    0,             //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black,             //color #0
    Onahau,             //color #1
    BuddhaGold,             //color #2
    Green,             //color #3
    0,            //x origin pixel
    0,            //y origin pixel
    Form1GraphicsD5Data,             //pointer to pixel data
    NULL  //click function pointer
};

FormNumberEdit Form1NumberEditD6 = {
    NumberEditType,             //Object type = NumberEdit
    52 + 8,     //Top tile #
    35,        //Left tile #
    2,              //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    White,          //Text foreground color
    RedBerry,       //Text background color
    Gallery,        //button color 0
    NavyBlue,       //button color 1
    Yellow,         //button color 2
    Yellow,         //button color 3
    49,              //value
    00,              //min. value
    63,             //max. vlaue
    2,              //#digits    
    10,             //base (10,2,16)
    &HandleNumberEditSpecialForm1,            //function to call when changed
    false,          //Show sign?               //This moved from above to below base due to bug in FlexSpin
    true,           //show buttons?
    false           //Affect only clicked digit?
};


int Form1GraphicsD6Data[64 * 4 * 16];
FormGraphicsArea Form1GraphicsD6 = {
    GraphicsAreaType,   //Object type GraphicsAreaType             
    52 + 8,                //Top tile #
    40,               //Left tile #
    64,              //Width in tiles
    4,             //Height in tiles
    0,               //user data
    0,             //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Black,             //color #0
    Onahau,             //color #1
    BuddhaGold,             //color #2
    Green,             //color #3
    0,            //x origin pixel
    0,            //y origin pixel
    Form1GraphicsD6Data,             //pointer to pixel data
    NULL  //click function pointer
};

FormNumberEdit Form1NumberEditA1 = {
    NumberEditType,             //Object type = NumberEdit
    27-6+1,     //Top tile #
    35,        //Left tile #
    2,              //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    White,          //Text foreground color
    RedBerry,       //Text background color
    Gallery,        //button color 0
    NavyBlue,       //button color 1
    Yellow,         //button color 2
    Yellow,         //button color 3
    10,              //value
    00,              //min. value
    63,             //max. vlaue
    2,              //#digits    
    10,             //base (10,2,16)
    &HandleNumberEditSpecialForm1,            //function to call when changed
    false,          //Show sign?               //This moved from above to below base due to bug in FlexSpin
    true,           //show buttons?
    false           //Affect only clicked digit?
};


int Form1GraphicsA1Data[64 * 6 * 16];
FormGraphicsArea Form1GraphicsA1 = {
    GraphicsAreaType,   //Object type GraphicsAreaType             
    27-6,                //Top tile #
    40,               //Left tile #
    64,              //Width in tiles
    6,             //Height in tiles
    0,               //user data
    0,             //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    NavyBlue,             //color #0
    Onahau,             //color #1
    BuddhaGold,             //color #2
    Green,             //color #3
    0,            //x origin pixel
    0,            //y origin pixel
    Form1GraphicsA1Data,             //pointer to pixel data
    NULL  //click function pointer
};

FormNumberEdit Form1NumberEditA2 = {
    NumberEditType,             //Object type = NumberEdit
    27-7+8+1,     //Top tile #
    35,        //Left tile #
    2,              //Width in tiles
    4,              //Height in tiles
    0,              //user data
    0,              //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    White,          //Text foreground color
    RedBerry,       //Text background color
    Gallery,        //button color 0
    NavyBlue,       //button color 1
    Yellow,         //button color 2
    Yellow,         //button color 3
    11,              //value
    00,              //min. value
    63,             //max. vlaue
    2,              //#digits    
    10,             //base (10,2,16)
    &HandleNumberEditSpecialForm1,            //function to call when changed
    false,          //Show sign?               //This moved from above to below base due to bug in FlexSpin
    true,           //show buttons?
    false           //Affect only clicked digit?
};


int Form1GraphicsA2Data[64 * 6 * 16];
FormGraphicsArea Form1GraphicsA2 = {
    GraphicsAreaType,   //Object type GraphicsAreaType             
    27 - 7 + 8,                //Top tile #
    40,               //Left tile #
    64,              //Width in tiles
    6,             //Height in tiles
    0,               //user data
    0,             //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    NavyBlue,             //color #0
    Onahau,             //color #1
    BuddhaGold,             //color #2
    Green,             //color #3
    0,            //x origin pixel
    0,            //y origin pixel
    Form1GraphicsA2Data,             //pointer to pixel data
    NULL  //click function pointer
};

__pasm {
dSmartPin
    file "sp.dat"
}

FormGraphicsArea Form1GraphicsSPA1 = {
    GraphicsAreaType,   //Object type GraphicsAreaType             
    24,                //Top tile #
    31,               //Left tile #
    2,              //Width in tiles
    2,             //Height in tiles
    0,               //user data
    0,             //status: Lowest bit of status is invisible flag, Second lowest bit is disabled flag
    Gallery,             //color #0
    Blue,             //color #1
    BuddhaGold,             //color #2
    Green,             //color #3
    0,            //x origin pixel
    0,            //y origin pixel
    &dSmartPin,             //pointer to pixel data
    &HandleMouseUpForm1  //click function pointer
};

FormObjectList Form1Objects = { {
        //Zero terminated list of form objects
        (FormObject*)&Form1Button1,
        (FormObject*)&Form1Button2,
        (FormObject*)&Form1Button3,
        (FormObject*)&Form1Button4,
        (FormObject*)&Form1Button5,
        (FormObject*)&Form1Button6,
        (FormObject*)&Form1Text1,
        (FormObject*)&Form1Text2,
        (FormObject*)&Form1Text3,
        (FormObject*)&Form1Text4,
        (FormObject*)&Form1Text5,
        (FormObject*)&Form1Text6,
        (FormObject*)&Form1Text7,
        (FormObject*)&Form1Text8,
        (FormObject*)&Form1Text9,
        (FormObject*)&Form1Text10,
        (FormObject*)&Form1Text11,
        (FormObject*)&Form1Group1,
        (FormObject*)&Form1Group2,
        (FormObject*)&Form1Group3,
        (FormObject*)&Form1Group4,
        (FormObject*)&Form1Option1,
        (FormObject*)&Form1Option2,
        (FormObject*)&Form1Option3,
        (FormObject*)&Form1Option4,
        (FormObject*)&Form1Option5,
        (FormObject*)&Form1Option6,
        (FormObject*)&Form1Check1,
        (FormObject*)&Form1Slider1,
        (FormObject*)&Form1Slider2,
        (FormObject*)&Form1NumberEdit1,
        (FormObject*)&Form1NumberEditD1,
        (FormObject*)&Form1GraphicsD1,
        (FormObject*)&Form1NumberEditD2,
        (FormObject*)&Form1GraphicsD2,
        (FormObject*)&Form1NumberEditD3,
        (FormObject*)&Form1GraphicsD3,
        (FormObject*)&Form1NumberEditD4,
        (FormObject*)&Form1GraphicsD4,
        (FormObject*)&Form1NumberEditD5,
        (FormObject*)&Form1GraphicsD5,
        (FormObject*)&Form1NumberEditD6,
        (FormObject*)&Form1GraphicsD6,
        (FormObject*)&Form1NumberEditA1,
        (FormObject*)&Form1GraphicsA1,
        (FormObject*)&Form1NumberEditA2,
        (FormObject*)&Form1GraphicsA2,
        (FormObject*)&Form1Dial1,
        (FormObject*)&Form1Dial2,
        (FormObject*)&Form1DialA1,
        (FormObject*)&Form1DialA2,
        (FormObject*)&Form1GraphicsSPA1,
        (FormObject*)0,
    } };

int test = 6;

FormForm Form1 = {
    FormType,              //type==form
    1,              //Top tile#
    2,              //Left tile#
    Cols - 4,   //width in tiles
    Rows - 3,   //height in tiles
    0, //data
    0, //status
    NavyBlue,   //Border color
    Gallery,    //fill color
    "Propeller II Mixed Signal Oscilloscope\0",  //title bar text
    Yellow,     //color of title bar text
    0,              //pointer to parent form (or 0 if this is top form)
    &Form1Objects,   //pointer to NULL terminated list of form objects
    0,              //OnFormOpen function
    0,               //OnFormClose function
    &OnForm1Idle  //
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//Form Objects

//digitizer  'Note:  Need to set _clkfreq in this file for DDS to be right
struct __using("Digitizer1j") dig; //RJA:  Visual Studio will show an error here, but it's OK

//This is the regular version of graphics that uses a cog
struct __using("Graphics2f") gr2; //RJA:  Visual Studio will show an error here, but it's OK

//Direct Digital Synthesis cog here to make interesting analog traces
//Note:  Clock frequency is defined as a constant in this file, change if clkfreq is changed.
struct __using("DDS_1i") dds; //RJA:  Visual Studio will show an error here, but it's OK

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//Form Constants and Variables

//Allocate CPU cores (AKA cogs)
//These 5 cogs are required by Forms framework
//These three are set in the TileDriver file.  Uses cogs 4, 5 & 6
#define VGA_Cog  (4)
#define Color_Cog (VGA_Cog + 1) //needs to share LUT
#define Scan_Cog  (6)
//These are set here
#define KbMouse_Cog (3)
#define ThisCog (0)

//These remaining three cogs are application specific
//Three cogs left if you don't use a cog for Graphics
#define Graphics_Cog (7)  //Note:  You can now use an alternate version of Graphics that doesn't require a cog
//Two cogs left!  
#define digCog (2)  //digitial digitizer, one cog left!
#define ddsCog (1) //Uh Oh, no more cogs :(

//Vars for Digitizer
int mode; //0 = stopped, 1 = enabled, 2 = single
int cursor1x, cursor2x; //x position of cursor 1 and 2
int cursor1_a1, cursor2_a1, cursor1_a2, cursor1_a2; //value of analog data at cursor
bool bNeedRedraw; //flag to redraw all data

//Vars for smartpin interface
int RPIN[10] = { 0 }; //R register storage for Config. Smartpins button, 2 analog, 6 digital, and 1 trigger pin
int XPIN[10] = { 0 }; //same for X
int YPIN[10] = { 0 }; //same for Y
int SPin=0; //smartpin being edited 0..9
int NPin=0; //smartpin edited via configure button

#define scp_base (0)  //must be a multiple of 4, 1st pin is level-triggered input
#define scpmode (0b00000000000100011000000000110100)  //%0000_0000_000_100011_0000000_00_11010_0    'ADC/scope mode
#define trigger_level (0x90)  //scope trigger level
#define arm_level (0x70)  //scope arm level
#define scope_filter (0)  //scope filter: 0 = 68-tap, 1 = 45-tap, 2 = 28-tap
#define scp_x (((trigger_level&0xFC)<<8)+(arm_level&0xFC)+scope_filter)


//dial1 setting to clocks lookup data
int Dial2Clock[] = { 24, 50, 100, 200, 500, 1000, 2000, 5000, 10000, 20000, 50000, 100000, 200000, 500000, 1000000, 2000000, 5000000, 10000000 };


/////////////////////////////////////////////////////////////////////////////////////////////////////////
//Form Methods

void SelectDigitalTrigger() //disable the level control
{//switch to digital trigger mode
    EnableObject((FormObject*)&Form1Slider2, false);
    DrawObject((FormObject*)&Form1Slider2);
    dig.SetTriggerMode(0);
    //Seems we need to reset edge too
    if (Form1Option1.bSelected)//Rising edge?
        dig.SetEdgeMode(0); //rising edge
    else
        dig.SetEdgeMode(1); //falling edge
}

void SelectAnalogTrigger() //enable the level control
{//switch to analog trigger mode
    EnableObject((FormObject*)&Form1Slider2, true);
    DrawObject((FormObject*)&Form1Slider2);
    dig.SetTriggerMode(1);
    _cogatn(1 << digCog); //restart acquisition
    SetAnalogTrigger();  //Set smartpin trigger value
}

void SetAnalogTrigger()
{//Set smartpin trigger value
    int i = Form1Slider2.value;  //get trigger level
    int y;
    if (Form1Option1.bSelected)
    {//rising edge
        y = i - 16;
        if (y < 0)
            y = 128;
    }
    else
    {//falling edge
        y = i + 16;
        if (y > 255)
            y = 128;
    }
    int x = ((i & 0xFC) << 8) + ((y & 0xFC)) + 0;
    int j = Form1NumberEdit1.value;
    _wxpin(j, x);
}

void HandleWaitMouseUpSpecialForm1(FormObject* pO)
{//App specific things mouse is down on an object (mainly for sliders and dials)
    if (pO->type == SliderType)
    {
        FormSlider* p = (FormSlider*)pO;
        if (p == &Form1Slider2)
        {//down on the level control
            SetAnalogTrigger();
        }
        else if (p == &Form1Slider1)
        {//down on the trigger delay control
            dig.SetPretrigger(Form1Slider1.value);
        }
    }
    else if (pO->type == DialType)
    {
        FormDial* p = (FormDial*)pO;
        if (p == &Form1Dial1)
        {//Change horizontal timebase coursely
            int x = Dial2Clock[p->value];//this
            int y= Dial2Clock[p->value+1]; //next
            x = x + ((y - x) * Form1Dial2.value) / 256;  //add in fine control
            Form1Text9.data = x;  //Save clocks in cursor text
            sprintf(Form1Text5.pText, "Clocks/Point:  %7.d ", x);
            DrawObject((FormObject*)&Form1Text5);
            dig.SetWait(x - 24); //update digitizer time between points to be setting minus miniumum
        }
        else if (p == &Form1Dial2)
        {//Change horizontal timebase pin finely
            int x = Dial2Clock[Form1Dial1.value];//this
            int y = Dial2Clock[Form1Dial1.value + 1]; //next
            x = x + ((y - x) * p->value) / 256;  //add in fine control
            Form1Text9.data = x;  //Save clocks in cursor text
            sprintf(Form1Text5.pText, "Clocks/Point:  %7.d ", x);
            DrawObject((FormObject*)&Form1Text5);
            dig.SetWait(x - 24); //update digitizer time between points to be setting minus miniumum
        }
        else if (p == &Form1DialA1)
        {//CH A1 gain
            int i = Form1NumberEditA1.value;
            int j = 0b100011 + p->value;
            j = (j << 15) | (RPIN[0] & 0b11111111111000000111111111111110); //%11111111_111_0000001111111_11_11111_0
            _wrpin(i,j);
        }
        else if (p == &Form1DialA2)
        {//CH A2 gain
            int i = Form1NumberEditA2.value;
            int j = 0b100011 + p->value;
            j = (j << 15) | (RPIN[1] & 0b11111111111000000111111111111110); //%11111111_111_0000001111111_11_11111_0
            _wrpin(i, j);
        }
    }
    

}

void HandleOptionSpecialForm1(FormObject* pO)
{//App specific things when an option is selected
    FormOption* p = (FormOption*)pO;

    if ((p == &Form1Option1) || (p == &Form1Option2))
    {
        if (Form1Option1.bSelected)  //Rising Edge selected?
        {
            dig.SetEdgeMode(0); //rising edge
        }
        else
        {
            dig.SetEdgeMode(1); //falling edge
        }
        SetAnalogTrigger(); //Change trigger settings in smartpin for analog mode
        _cogatn(1 << digCog); //need to restart acquistion
    }
    else if (p == &Form1Option3)
    {//digital trigger
        SelectDigitalTrigger();
    }
    else if (p == &Form1Option4)
    {//digital trigger
        SelectAnalogTrigger();
    }
}

void HandleNumberEditSpecialForm1(FormObject* pO)
{//App specific things when a numberedit value is changed
    FormNumberEdit* p = (FormNumberEdit*)pO;
    
    if (p == &Form1NumberEdit1)
    {//Change trigger pin
        int i = p->value;
        dig.SetTriggerPin(i);
        if (dig.GetTriggerMode() == 1)  //analog?
        {//Change to digital trigger when pin changes and in analog trigger mode
            HandleMouseUpOption(@Form1Option3);// select digital
            SelectDigitalTrigger();
        }
        //need to restart acquistion
        _cogatn(1 << digCog);
    }
    else if (p == &Form1NumberEditA1) 
    {//Analog CH#1 pin change
        dig.SetAnalogPin(1, p->value);
        //need to restart acquistion
        _cogatn(1 << digCog);
    }
    else if (p == &Form1NumberEditA2)
    {//Analog CH#1 pin change
        dig.SetAnalogPin(2, p->value);
        //need to restart acquistion
        _cogatn(1 << digCog);
    }
}

void HandleMouseUpForm1(FormObject* pO)
{//Do special things when graphics area clicked on Form1
    if (pO == &Form1GraphicsSPA1)
        printf("Clicked on SP!\n");
}

void HandleButtonUpSpecialForm1(FormObject* pO)
{//Take care of most button presses here
    printf("&1\n");
    FormButton* p = (FormButton*)pO;
    if (p == &Form1Button1)
    {//'start button
        mode = 1;  ////0 = stopped, 1 = enabled, 2 = single
        dig.SetMode(mode);
        //force acceptance
        _cogatn(1 << digCog);
    }
    else if (p == &Form1Button2)
    {//'stop button
        mode = 0;  ////0 = stopped, 1 = enabled, 2 = single
        dig.SetMode(mode);
        //force acceptance  
        _cogatn(1 << digCog);
        
    }
    else if (p == &Form1Button3)
    {//'single button
        mode = 2;  ////0 = stopped, 1 = enabled, 2 = single
        dig.SetMode(mode);
        //force acceptance 
        _cogatn(1 << digCog);
    }
    
}

void DrawAnalogData(int p, FormGraphicsArea* pg, int ch)
{//Draw analog Trace gving buffer pointer, p, and graphics object pointer, pg, and chanel, ch
    //Note:  Although p is actually a pointer, treating as int here to match Spin2 source (at least for the moment)

    //setup graphics
    int* p1 = pg->pData;
    //printf("%d, %d, %d, %d\n", pg->width, pg->height, pg->xOrigin, pg->yOrigin);
    gr2.Setup(pg->width, pg->height, pg->xOrigin, pg->yOrigin, bitmap_base);
    gr2.Clear();

    //draw some vertical grid lines
    for (int x = 0; x < ((pg->width << 4) - 1); x += 16)
    {
        gr2.ColorWidth(3, 0);
        gr2.Plot(x, 0);
        gr2.Line(x, 95);
    }

    int x = dig.GetPreTrigger(); //'#points of pretrigger, actually # points after trigger
    //draw trigger point    
    gr2.colorwidth(2, 25);//set color and width
    gr2.plot(dig.points - x, 0);
    gr2.line(dig.points - x, 95);

    //Draw Data
    int ps = dig.GetTriggerPointer();
    //set color and width
    gr2.colorwidth(1, 2);
    ps += x * 2 * 4 * 2;  //put trigger point in place, point past data after trigger
    if (ps >= (p + dig.points * 2 * 4 * 2)) //Past the end of array?
        ps -= dig.points * 2 * 4 * 2;  //wrap around

    int pe = ps;  //save for cursor data

    int i;
    //Plot first point
    if (ch == 0)
        i = *(int*)(ps + 8);
    else
        i = *(int*)(ps + 12);

    i = i & 0xFF;
    gr2.plot(0, 5 + i * (96 - 10) / 256);

    for (int x = 0; x < 1024; x++)
    {//plot other points
        if (ch == 0)
            i = *(int*)(ps + 8);
        else
            i = *(int*)(ps + 12);

        i = i & 0xFF;
        gr2.line(x, 5 + i * (96 - 10) / 256);
        ps += 16;

        if (ps >= (p + dig.points * 2 * 4 * 2)) //Past the end of array?
            ps = p; //wrap around
    }

    gr2.copy(p1);


}

void DrawDigitalData(int p, FormGraphicsArea* pg, int ch)
{//Draw digital Trace gving buffer pointer, p, and graphics object pointer, pg, and chanel, ch
    //Note:  Although p is actually a pointer, treating as int here to match Spin2 source (at least for the moment)

    //setup graphics
    int* p1 = pg->pData;
    //printf("%d, %d, %d, %d\n", pg->width, pg->height, pg->xOrigin, pg->yOrigin);
    gr2.Setup(pg->width, pg->height, pg->xOrigin, pg->yOrigin, bitmap_base);
    gr2.Clear();


    //draw some vertical grid lines
    for (int x = 0; x < ((pg->width << 4) - 1); x += 16)
    {
        gr2.ColorWidth(3, 0);
        gr2.Plot(x, 0);
        gr2.Line(x, 63);
    }


    int x = dig.GetPreTrigger(); //'#points of pretrigger, actually # points after trigger
    //draw trigger point
    gr2.colorwidth(2, 25);      //set color and width
    gr2.plot(dig.points - x, 0);
    gr2.line(dig.points - x, 63);

    int ps = dig.GetTriggerPointer();
    //set color and width
    gr2.colorwidth(1, 2);

    ps += x * 2 * 4 * 2;  //put trigger point in place, point past data after trigger
    if (ps >= (p + dig.points * 2 * 4 * 2)) //Past the end of array?
        ps -= dig.points * 2 * 4 * 2;  //wrap around

    int m, i;
    if (ch > 31)
    {
        m = 1 << (ch - 32);  //mask for inb

        i=*(int*)(ps + 4);
    }
    else
    {
        m = 1 << ch;
        i = *(int*)ps;
    }

    if ((i & m) > 0)
        gr2.plot(0, 63 - 10); //start high
    else
        gr2.plot(0, 10);  //start low

    for (int x = 0; x < 1024; x++)
    {
        if (ch > 31)
        {
            i = *(int*)(ps + 4);
        }
        else
        {
            i = *(int*)ps;
        }

        if ((i & m) > 0)
            gr2.line(x, 63 - 10); //start high
        else
            gr2.line(x, 10);  //start low
        ps += 16; //next point
        if (ps >= (p + dig.points * 2 * 4 * 2)) //Past the end of array?
            ps = (int)p;  //wrap around
    }


    gr2.copy(p1);
}

void RedrawData()
{//Redraw digitizer data
    bNeedRedraw = 0; // done redrawing
    int p = dig.GetBuffer();
    VSync();
    DrawDigitalData(p, &Form1GraphicsD1, Form1NumberEditD1.value);
    DrawDigitalData(p, &Form1GraphicsD2, Form1NumberEditD2.value);
    DrawDigitalData(p, &Form1GraphicsD3, Form1NumberEditD3.value);
    DrawDigitalData(p, &Form1GraphicsD4, Form1NumberEditD4.value);
    DrawDigitalData(p, &Form1GraphicsD5, Form1NumberEditD5.value);
    DrawDigitalData(p, &Form1GraphicsD6, Form1NumberEditD6.value);
    DrawAnalogData(p, &Form1GraphicsA1, 0); //first analog channel
    DrawAnalogData(p, &Form1GraphicsA2, 1); //second analog channel
}

void OnForm1Idle(int unused)
{//Do special background things for Form1 (digitizer)
    int i = dig.GetStatus();
    ShowDigStatus(i);
    if ((i == 1) || (bNeedRedraw == 1)) //Draw new data?
    {//Draw new data
        RedrawData();
        dig.SetStatus(0);
    }
    //dig.SetPretrigger(Form1Slider1.value);
}

void ShowDigStatus(int i)
{//show digitizer status
    vga.SetCol(18);
    vga.SetRow(8);
    vga.SetBackcolor(Gallery);
    switch (i)
    {
    case 0:
        vga.SetForecolor(Red);
        vga.print_string("Disabled ");
        break;
    case 4:
        vga.SetForecolor(Green);
        vga.print_string("Waiting  ");
        break;
    case 1:
        vga.SetForecolor(Blue);
        vga.print_string("Triggered");
        break;
    default:
        break;
    }
}

